#!/bin/sh
-# Please do not edit this file. It is generated automatically from
-# configure.in and a configure template.
-configdirs=
-
-# the debugger.
-#set -x
-#!/bin/sh
-
-# Configuration script template
+# Configuration script
# Copyright (C) 1988, 1990, 1991 Free Software Foundation, Inc.
#This file is part of GNU.
-#GNU CC is free software; you can redistribute it and/or modify
-#it under the terms of the GNU General Public License as published by
-#the Free Software Foundation; either version 1, or (at your option)
-#any later version.
-
-#GNU CC is distributed in the hope that it will be useful,
-#but WITHOUT ANY WARRANTY; without even the implied warranty of
-#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
-#GNU General Public License for more details.
-
-#You should have received a copy of the GNU General Public License
-#along with GNU CC; see the file COPYING. If not, write to
-#the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */
# $Id$
+# Please email any bugs, comments, and/or additions to this file to:
+
#
# Shell script to create proper links to machine-dependent files in
# preparation for compilation.
# config.status is removed.
#
+# NOTE: This script contains support for a Cygnus experimental feature, called
+# +subdirs, which is currently, tentatively, de-supported.
+
+export PATH || (echo "OOPS, this isn't sh. Desperation time. I will feed myself to sh."; sh $0 $argv; kill $$)
+
remove=rm
hard_link=ln
symbolic_link='ln -s'
#hard_link="echo ln"
#symbolic_link="echo ln -s"
-progname=$0
-
# clear some things potentially inherited from environment.
-ansi=
+
+Makefile=Makefile
+Makefile_in=Makefile.in
+arguments=$*
+commontargets=
+configdirs=
+datadir=
+datadiroption=
defaulttargets=
-destdir=
fatal=
-hostsubdir=
-norecurse=
+floating_point=default
+gas=default
+hosts=
+#hostsubdir=
+#namesubdir=
+next_prefix=
+next_host=
+#next_namesubdir=
+#next_objdir=
+next_site=
+next_srcdir=
+next_target=
+next_tmpdir=
+norecursion=
+#objdir=
+#objdiroption=
+prefix=/usr/local
+progname=
+recurring=
removing=
srcdir=
srctrigger=
target=
targets=
-targetsubdir=
-template=
+#targetsubdir=
+undefinedargs=
verbose=
+version="$Revision$"
+x11=default
+
+# or maybe grab from gcc/version.c
+version_path=
+next_version_path=
+
+NO_EDIT="This file was generated automatically by configure. Do not edit."
+
+## this is a little touchy and won't always work, but...
+##
+## if the argv[0] starts with a slash then it is an absolute name that can be
+## used as is.
+##
+## otherwise, if argv[0] has no slash in it, we can assume that it is on the
+## path. Since PATH might include "." we also add `pwd` to the end of PATH.
+##
+## otherwise we prepend `pwd` to $0 and hope that will give us an absolute
+## path.
+##
+
+PWD=`pwd`
+
+if (echo $0 | grep '^/' > /dev/null) ; then
+ progname=$0
+elif (echo $0 | grep '/' > /dev/null) ; then
+ progname=${PWD}/$0
+else
+ progname=$0
+ PATH=$PATH:${PWD} ; export PATH
+fi
for arg in $*;
do
- case ${arg} in
- -ansi | +ansi)
- ansi=true
- ;;
- -destdir=* | +destdir=* | +destdi=* | +destd=* | +dest=* | +des=* | +de=* | +d=*)
- destdir=`echo ${arg} | sed 's/[+-]d[a-z]*=//'`
- ;;
- -forcesubdirs | +forcesubdirs | +forcesubdir | +forcesubdi | +forcesubd \
- | +forcesub | +forcesu | +forces | +force | +forc | +for | +fo | +f)
- forcesubdirs=${arg}
- ;;
- -languages=* | +languages=* | +language=* | +languag=* \
- | +langua=* | +langu=* | +lang=* | +lan=* | +la=* \
- | +l=*)
- languages="${languages} `echo ${arg} | sed 's/[+-]l[a-z]*=//'`"
- ;;
- -gas | +gas | +ga | +g)
- gas=yes
- ;;
- -help | +h | +help)
- fatal=true
- ;;
- -nfp | +nfp | +nf | +n)
- nfp=yes
- ;;
- -norecurse | +norecurse)
- norecurse=true
- ;;
- -rm | +rm)
- removing=${arg}
- ;;
-# -srcdir=* | +srcdir=* | +srcdi=* | +srcd=* | +src=* | +sr=* | +s=*)
-# srcdir=`echo ${arg} | sed 's/[+-]s[a-z]*=//'`
-# ;;
- -target=* | +target=* | +targe=* | +targ=* | +tar=* | +ta=* | +t=*)
- if [ -n "${targets}" ] ; then
- forcesubdirs="+forcesubdirs"
- fi
-
- newtargets="${targets} `echo ${arg} | sed 's/[+-]t[a-z]*=//'`"
- targets="${newtargets}"
- ;;
- -template=* | +template=*)
- template=`echo ${arg} | sed 's/[+-]template=//'`
- ;;
- +verbose | +verbos | +verbo | +verb | +ver | +ve | +v)
- verbose=${arg}
- ;;
- -* | +*)
- (echo ;
- echo "Unrecognized option: \"${arg}\"". ;
- echo) 1>&2
- fatal=true
- ;;
- *)
- if [ -n "${hosts}" ] ; then
- forcesubdirs="+forcesubdirs"
+ # handle things that might have args following as separate words
+ if [ -n "${next_prefix}" ] ; then prefix=${arg} ; prefixoption="-prefix=${prefix}" ; next_prefix=
+ elif [ -n "${next_datadir}" ] ; then datadir=${arg} ; datadiroption="-datadir=${datadir}" ; next_datadir=
+# elif [ -n "${next_namesubdir}" ] ; then \
+# namesubdir=${arg} ; namesubdiroption="--namesubdir=${namesubdir}" ; next_namesubdir=
+# elif [ -n "${next_objdir}" ] ; then objdir=${arg} ; objdiroption="--objdir=${objdir}" ; next_objdir=
+ elif [ -n "${next_version_path}" ] ; then version_path=${arg} ; next_version_path=
+ elif [ -n "${next_site}" ] ; then site=${arg} ; next_site=
+ elif [ -n "${next_srcdir}" ] ; then srcdir=${arg} ; next_srcdir=
+ elif [ -n "${next_target}" ] ; then
+ next_target=
+ if [ -z "${targets}" ] ; then
+ newtargets="${targets} ${arg}"
+ targets="${newtargets}"
+ else
+ echo '***' Can only configure for one target at a time.
+ fatal=yes
fi
+ elif [ -n "${next_tmpdir}" ] ; then
+ next_tmpdir=
+ tmpdiroption="--tmpdir=${arg}"
+ TMPDIR=${arg}
- newhosts="${hosts} ${arg}"
- hosts=${newhosts}
- ;;
- esac
+ else
+ case ${arg} in
+ -datadir=* | --datadir=* | --datadi=* | --datad=* | --data=* | --dat=* | --da=* | --d=*)
+ datadir=`echo ${arg} | sed 's/^[-a-z]*=//'`
+ datadiroption=${arg}
+ ;;
+ -datadir | --datadir | --datadi | --datad | --data | --dat | --da | --d)
+ next_datadir=yes
+ ;;
+ -gas | --g*)
+ gas=yes
+ ;;
+ -help | --he*)
+ fatal=true
+ ;;
+ -host=* | --host=* | --hos=* | --ho=*)
+# if [ -n "${hosts}" ] ; then
+# subdirs="--subdirs"
+# fi
+
+ if [ -z "${hosts}" ] ; then
+ newhosts="${hosts} `echo ${arg} | sed 's/^[-a-z]*=//'`"
+ hosts="${newhosts}"
+ else
+ echo '***' Can only configure for one host at a time.
+ fatal=yes
+ fi
+ ;;
+# -namesubdir | --namesubdir | --namesubdi | --namesubd | --namesub | --namesu | --names | --name | --nam | --na)
+# next_namesubdir=yes
+# ;;
+# -namesubdir=* | --namesubdir=* | --namesubdi=* | --namesubd=* | --namesub=* | --namesu=* | --names=* | --name=* | --nam=* | --na=*)
+# namesubdir=`echo ${arg} | sed 's/^[-a-z]*=//'`
+# namesubdiroption=${arg}
+# ;;
+ -nfp | --nf*)
+ floating_point=no
+ ;;
+ -norecursion | --no*)
+ norecursion=true
+ ;;
+# -objdir=* | --objdir=* | --objdi=* | --objd=* | --obj=* | --ob=* | --o=*)
+# objdiroption=${arg}
+# objdir=`echo ${arg} | sed 's/^[-a-z]*=//'`
+# ;;
+# -objdir | --objdir | --objdi | --objd | --obj | --ob | --o)
+# next_objdir=yes
+# ;;
+ -prefix=* | --prefix=* | --prefi=* | --pref=* | --pre=* | --pr=* | --p=*)
+ prefix=`echo ${arg} | sed 's/^[-a-z]*=//'`
+ prefixoption=${arg}
+ ;;
+ -prefix | --prefix | --prefi | --pref | --pre | --pr | --p)
+ next_prefix=yes
+ ;;
+ -recurring | --recurring | --recurrin | --recurri | --recurr | --recur | --recu | --rec | --re)
+ recurring=true
+ arguments=`echo ${arguments} | sed "s:${arg}::"`
+ ;;
+ -rm | --rm)
+ removing=${arg}
+ ;;
+ -site=* | --site=* | --sit=* | --si=*)
+ site=`echo ${arg} | sed 's/^[-a-z]*=//'`
+ ;;
+ -site | --site | --sit | --si)
+ next_site=yes
+ ;;
+ -srcdir=* | --srcdir=* | --srcdi=* | --srcd=* | --src=* | --sr=*)
+ srcdir=`echo ${arg} | sed 's/^[-a-z]*=//'`
+ ;;
+ -srcdir | --srcdir | --srcdi | --srcd | --src | --sr)
+ next_srcdir=yes
+ ;;
+# -subdirs | --su*)
+# subdirs=${arg}
+# ;;
+ -target=* | --target=* | --targe=* | --targ=* | --tar=* | --ta=*)
+# if [ -n "${targets}" ] ; then
+# subdirs="--subdirs"
+# fi
+
+ if [ -z "${targets}" ] ; then
+ newtargets="${targets} `echo ${arg} | sed 's/^[-a-z]*=//'`"
+ targets="${newtargets}"
+ else
+ echo '***' Can only configure for one target at a time.
+ fatal=yes
+ fi
+ ;;
+ -target | --target | --targe | --targ | --tar | --ta)
+ next_target=yes
+ ;;
+ -tmpdir=* | --tmpdir=* | --tmpdi=* | --tmpd=* | --tmp=* | --tm=*)
+ tmpdiroption=${arg}
+ TMPDIR=`echo ${arg} | sed 's/^[-a-z]*=//'`
+ ;;
+ -tmpdir | --tmpdir | --tmpdi | --tmpd | --tmp | --tm)
+ next_tmpdir=yes
+ ;;
+ -v | -verbose | --v)
+ verbose=${arg}
+ ;;
+ -version | -V | --version | --V)
+ echo "This is Cygnus Configure version" `echo ${version} | sed 's/[ $:]//g'`
+ exit 0
+ ;;
+ -x | --x) ;;
+ -* | --*)
+ (echo ;
+ echo "Unrecognized option: \"${arg}\"". ;
+ echo) 1>&2
+ fatal=true
+ ;;
+ *)
+# if [ -n "${hosts}" ] ; then
+# subdirs="--subdirs"
+# fi
+
+ if [ -z "${undefs}" ] ; then
+ newundefs="${undefs} ${arg}"
+ undefs=${newundefs}
+ else
+ echo '***' Can only configure for one host and one target at a time.
+ fatal=yes
+ fi
+ ;;
+ esac
+ fi
done
if [ -n "${verbose}" ] ; then
- echo `pwd`/configure $*
- echo targets=\"${targets}\"
+ echo $0 $*
fi
-# process host and target only if not rebuilding configure itself or removing.
-if [ -z "${template}" -a -z "${removing}" -a -z "${fatal}" ] ; then
- # Complain if an arg is missing
- if [ -z "${hosts}" ] ; then
- (echo ;
- echo "configure: No HOST specified." ;
- echo) 2>&1
- fatal=true
+# process host and target
+if [ -z "${fatal}" ] ; then
+# # Complain if an arg is missing
+# if [ -z "${hosts}" ] ; then
+# (echo ;
+# echo "configure: No HOST specified." ;
+# echo) 1>&2
+# fatal=true
+# fi
+
+### This is a bit twisted.
+### * if all three are specified, this is an error.
+### * if we have neither hosts, nor unadorned args, this is an error.
+### * if no hosts are specified, then the unadorned args are hosts, but if
+### there were none, this is an error.
+### * if no targets are specified, then the unadorned args are targets, but if
+### there were no unadorned args, then the hosts are also targets.
+
+ if [ -n "${hosts}" -a -n "${targets}" -a -n "${undefs}" ] ; then
+ echo '***' Can only configure for one host and one target at a time.
+ fatal=yes
+ elif [ -z "${hosts}" -a -z "${undefs}" ] ; then
+ echo '***' You must tell me for which host you want to configure.
+ fatal=yes
+ else
+ if [ -z "${hosts}" ] ; then
+ hosts=${undefs}
+ fi
+
+ if [ -z "${targets}" ] ; then
+ if [ -n "${undefs}" ] ; then
+ targets=${undefs}
+ else
+ targets=${hosts}
+ fi
+ fi
fi
fi
(echo "Usage: configure HOST" ;
echo ;
echo "Options: [defaults in brackets]" ;
- echo " +ansi configure w/ANSI library. [no ansi lib]" ;
- echo " +destdir=MYDIR configure for installation into MYDIR. [/usr/local]" ;
- echo " +forcesubdirs configure in subdirectories. [in source directories]" ;
- echo " +lang=LANG configure to build LANG. [gcc]" ;
- echo " +help print this message. [normal config]" ;
- echo " +gas configure the compilers for use with gas. [native as]" ;
- echo " +nfp configure the compilers default to soft floating point. [hard float]" ;
- echo " +norecurse configure this directory only. [recurse]" ;
- echo " +rm remove this configuration. [build a configuration]" ;
- echo " +target=TARGET configure for TARGET. [TARGET = HOST]" ;
- echo " +template=TEM rebuild configure using TEM. [normal config]" ;
+ echo " -datadir=MYDIR configure for installation of host dependent files into MYDIR. [\"/usr/local\"]" ;
+ echo " -gas configure the compilers for use with gas. [native as]" ;
+ echo " -help print this message. [normal config]" ;
+ echo " -lang=LANG configure to build LANG. [gcc]" ;
+ echo " -nfp configure the compilers default to soft floating point. [hard float]" ;
+ echo " -norecursion configure this directory only. [recurse]" ;
+# echo " -objdir=ODIR configure in a parallel tree rooted in ODIR. [rooted in \".\"]" ;
+ echo " -prefix=MYDIR configure for installation of host dependent files into MYDIR. [\"/usr/local\"]" ;
+ echo " -rm remove this configuration. [build a configuration]" ;
+ echo " -site configure with site specific makefile" ;
+ echo " -srcdir=DIR find the sources in DIR. [\".\" or \"..\"]" ;
+# This is correctly aligned in the output, even though it isn't here.
+# echo " -subdirs configure in subdirectories. [in source directories]" ;
+ echo " -target=TARGET configure for TARGET. [TARGET = HOST]" ;
+ echo " -tmpdir=TMPDIR create temporary files in TMPDIR. [ TMPDIR = \"/tmp\" ]" ;
echo ;
echo "Where HOST and TARGET are something like \"vax\", \"sun3\", \"encore\", etc." ;
- echo "Asking for more than one \"+target\" implies \"+forcesubdirs\". Any other" ;
- echo "options given will apply to all targets.") 1>&2
+# echo "Asking for more than one \"--target\" implies \"--subdirs\". Any other" ;
+# echo "options given will apply to all targets."
+ ) 1>&2
if [ -r config.status ] ; then
cat config.status
exit 1
fi
-#### configure.in common parts come in here.
-# This file is a shell script fragment that supplies the information
-# necessary to tailor a template configure script into the configure
-# script appropriate for this directory. For more information, check
-# any existing configure script.
-
-configdirs="libiberty bfd binutils ld gas readline gcc gnulib clib"
-srctrigger=README.configure
-srcname="gnu development package"
-
-## end of common part.
-
-# are we rebuilding config itself?
-if [ -n "${template}" ] ; then
- if [ ! -r ${template} ] ; then
- echo "Can't find template ${template}."
- exit 1
- fi
+configsub=`echo ${progname} | sed 's/configure$/config.sub/'`
-# prep the template
- sed -e '/^#### configure.in common parts come in here.$/,/^## end of common part.$/c\
-#### configure.in common parts come in here.\
-## end of common part.' \
- -e '/^#### configure.in per-host parts come in here.$/,/^## end of per-host part.$/c\
-#### configure.in per-host parts come in here.\
-## end of per-host part.' \
- -e '/^#### configure.in per-target parts come in here.$/,/^## end of per-target part.$/c\
-#### configure.in per-target parts come in here.\
-## end of per-target part.' \
- < ${template} > template.new
+if (${configsub} `echo ${hosts} | sed -e 's/ .*//'`) >/dev/null 2>&1 ; then
+ true
+else
+ echo '***' cannot find config.sub.
+ exit 1
+fi
+if [ -z "${srcdir}" ] ; then
if [ -r configure.in ] ; then
- if [ -z "`grep '^# per\-host:' configure.in`" ] ; then
- echo `pwd`/configure.in has no "per-host:" line.
- exit 1
- fi
-
- if [ -z "`grep '^# per\-target:' configure.in`" ] ; then
- echo `pwd`/configure.in has no "per-target:" line.
- exit 1
- fi
-
- # split configure.in into common, per-host, and per-target parts
- sed -e '/^# per\-host:/,$d' configure.in > configure.com
- sed -e '1,/^# per\-host:/d' -e '/^# per\-target:/,$d' configure.in > configure.hst
- sed -e '1,/^# per\-target:/d' configure.in > configure.tgt
-
- # and insert them
- sed -e '/^#### configure.in common parts come in here.$/ r configure.com' \
- -e '/^#### configure.in per\-host parts come in here.$/ r configure.hst' \
- -e '/^#### configure.in per\-target parts come in here.$/ r configure.tgt' \
- template.new > configure.new
-
- rm -f configure.com configure.tgt configure.hst
+ srcdir=.
+ elif [ -r ../configure.in ] ; then
+ srcdir=..
else
- echo Warning: no configure.in in `pwd`
- cat ${template} >> configure
+ echo '***' "Can't find configure.in. Try using -srcdir=some_dir"
+ exit 1
fi
+fi
- chmod a+x configure.new
- rm template.new
-# mv configure configure.old
- mv configure.new configure
- echo Rebuilt configure in `pwd`
- if [ -z "${norecurse}" ] ; then
- while [ -n "${configdirs}" ] ; do
- # set configdir to car of configdirs, configdirs to cdr of configdirs
- set ${configdirs}; configdir=$1; shift; configdirs=$*
+### break up ${srcdir}/configure.in.
+if [ -z "`grep '^# per\-host:' ${srcdir}/configure.in`" ] ; then
+ echo '***' ${srcdir}/configure.in has no "per-host:" line. 1>&2
+ exit 1
+fi
- if [ "`echo ${configdir}.*`" != "${configdir}.*" ] ; then
- targetspecificdirs=${configdir}.*
- else
- targetspecificdirs=
- fi
+if [ -z "`grep '^# per\-target:' ${srcdir}/configure.in`" ] ; then
+ echo '***' ${srcdir}/configure.in has no "per-target:" line. 1>&2
+ exit 1
+fi
- for i in ${configdir} ${targetspecificdirs} ; do
- if [ -d $i ] ; then
- if [ -r $i/configure ] ; then
- (cd $i ;
- ./configure +template=${template} ${verbose})
- else
- echo No configure script in `pwd`/$i
- fi
- else
- echo Warning: directory $i is missing.
- fi
- done
- done
- fi
+if [ -z "${TMPDIR}" ] ; then
+ TMPDIR=/tmp ; export TMPDIR
+fi
- exit 0
+# keep this filename short for &%*%$*# 14 char file names
+tmpfile=${TMPDIR}/cONf$$
+trap "rm -f ${tmpfile}.com ${tmpfile}.tgt ${tmpfile}.hst ${tmpfile}.pos" 0
+
+# split ${srcdir}/configure.in into common, per-host, per-target,
+# and post-target parts. Post-target is optional.
+sed -e '/^# per\-host:/,$d' ${srcdir}/configure.in > ${tmpfile}.com
+sed -e '1,/^# per\-host:/d' -e '/^# per\-target:/,$d' ${srcdir}/configure.in > ${tmpfile}.hst
+if grep '^# post-target:' ${srcdir}/configure.in >/dev/null ; then
+ sed -e '1,/^# per\-target:/d' -e '/^# post\-target:/,$d' ${srcdir}/configure.in > ${tmpfile}.tgt
+ sed -e '1,/^# post\-target:/d' ${srcdir}/configure.in > ${tmpfile}.pos
+else
+ sed -e '1,/^# per\-target:/d' ${srcdir}/configure.in > ${tmpfile}.tgt
+ echo >${tmpfile}.pos
fi
+### do common part of configure.in
+
+. ${tmpfile}.com
+
# some sanity checks on configure.in
if [ -z "${srctrigger}" ] ; then
- echo srctrigger not set in configure.in. `pwd` not configured.
+ echo '***' srctrigger not set in ${PWD}/configure.in.
exit 1
fi
defaulttargets=true
fi
- host_makefile_frag=config/hmake-${host}
-
-#### configure.in per-host parts come in here.
-
-## end of per-host part.
+ host_alias=${host}
+
+ result=`${configsub} ${host}`
+ host_cpu=`echo $result | sed 's/^\(.*\)-\(.*\)-\(.*\)$/\1/'`
+ host_vendor=`echo $result | sed 's/^\(.*\)-\(.*\)-\(.*\)$/\2/'`
+ host_os=`echo $result | sed 's/^\(.*\)-\(.*\)-\(.*\)$/\3/'`
+ host=${host_cpu}-${host_vendor}-${host_os}
+ host_makefile_frag=config/mh-${host}
+ if [ ! -f ${host_makefile_frag} ]
+ then
+ host_makefile_frag=config/mh-${host_alias}
+ fi
+ . ${tmpfile}.hst
for target in ${targets} ; do
- if [ -n "${verbose}" ] ; then
- echo host \= \"${host}\", target \= \"${target}\".
+ target_alias=${target}
+ result=`${configsub} ${target}`
+ target_cpu=`echo $result | sed 's/^\(.*\)-\(.*\)-\(.*\)$/\1/'`
+ target_vendor=`echo $result | sed 's/^\(.*\)-\(.*\)-\(.*\)$/\2/'`
+ target_os=`echo $result | sed 's/^\(.*\)-\(.*\)-\(.*\)$/\3/'`
+ target=${target_cpu}-${target_vendor}-${target_os}
+ target_makefile_frag=config/mt-${target}
+ if [ ! -f ${target_makefile_frag} ]
+ then
+ target_makefile_frag=config/mt-${target_alias}
fi
- target_makefile_frag=config/tmake-${target}
+ . ${tmpfile}.tgt
-#### configure.in per-target parts come in here.
-## end of per-target part.
+ if [ "${host_alias}" = "${target_alias}" ] ; then
+ subdirname=H-${host_alias}
+ else
+ subdirname=X-${host_alias}-${target_alias}
+ fi
- # Temporarily, we support only direct subdir builds.
- hostsubdir=Host-${host}
- targetsubdir=Target-${target}
+ if [ -n "${namesubdir}" ] ; then
+ subdirname=${namesubdir}
+ fi
if [ -n "${removing}" ] ; then
- if [ -n "${forcesubdirs}" ] ; then
- if [ -d "${hostsubdir}" ] ; then
- rm -rf ${hostsubdir}/${targetsubdir}
-
- if [ -z "`(ls ${hostsubdir}) 2>&1 | grep Target-`" ] ; then
- rm -rf ${hostsubdir}
- fi
- else
- echo Warning: no `pwd`/${hostsubdir} to remove.
- fi
- else
- rm -f Makefile config.status ${links}
- fi
+# if [ -n "${objdir}" ] ; then
+# echo '***' --rm not supported for --objdir. Just \"rm -rf ${objdir}\" by hand.
+# exit 1
+# fi
+
+# if [ -n "${subdirs}" ] ; then
+# if [ -d "${subdirname}" ] ; then
+# rm -rf ${hostsubdir}
+# else
+# echo Warning: no ${PWD}/${hostsubdir} to remove.
+# fi
+# else
+ rm -f ${Makefile} config.status ${links}
+# fi
else
- if [ -n "${forcesubdirs}" ] ; then
- # check for existing status before allowing forced subdirs.
- if [ -f Makefile ] ; then
- echo "Makefile already exists in source directory. `pwd` not configured."
- exit 1
- fi
-
- if [ ! -d ${hostsubdir} ] ; then mkdir ${hostsubdir} ; fi
- cd ${hostsubdir}
-
- if [ ! -d ${targetsubdir} ] ; then mkdir ${targetsubdir} ; fi
- cd ${targetsubdir}
-
- srcdir=../..
- else
- # if not subdir builds, then make sure none exist.
- if [ -n "`(ls .) 2>&1 | grep Host-`" ] ; then
- echo "Configured subdirs exist. `pwd` not configured."
- exit 1
- fi
- fi
+# if [ -n "${objdir}" ]; then
+# srcdir=${PWD}
+# cd ${objdir}
+# fi
+
+# if [ -n "${subdirs}" ] ; then
+# # check for existing status before allowing forced subdirs.
+# if [ -f ${Makefile} ] ; then
+# echo '***' "${Makefile} already exists in source directory. ${PWD} not configured." 1>&2
+# exit 1
+# fi
+#
+# # use a subdir common to all targets for this host iff: this is a cross AND
+# # this tool does not claim to be target dependent AND we have not been asked to name the subdir.
+# if [ ${host_alias} != ${target_alias} -a -z "${target_dependent}" -a -z "${namesubdiroption}" ]
+# then
+# if [ ! -d H-${host_alias} ] ; then mkdir H-${host_alias} ; fi
+#
+# if (${symbolic_link} ${subdirname} H-${host_alias} 2> /dev/null) ; then
+# true
+# else # just give up. they lose.
+# rmdir H-${host_alias}
+# if [ ! -d ${subdirname} ] ; then mkdir ${subdirname} ; fi
+# fi
+# elif [ ! -d ${subdirname} ] ; then
+# mkdir ${subdirname}
+# fi
+#
+# cd ${subdirname}
+#
+# if [ -z "${srcdir}" ] ; then
+# srcdir=..
+# fi
+# elif [ "`echo H-*`" != "H-*" -a "`echo X-*`" != "X-*" ] ; then
+# # if not subdir builds, then make sure none exist.
+# # We might miss if there are explicitly named subdirs.
+# echo '***' "Configured subdirs exist. ${PWD} not configured." 1>&2
+# exit 1
+# else
+# true
+# fi
# Find the source files, if location was not specified.
if [ -z "${srcdir}" ] ; then
srcdirdefaulted=1
srcdir=.
- if [ -n "${srctrigger}" -a ! -r ${srctrigger} ] ; then
+ if [ ! -r ${srctrigger} ] ; then
srcdir=..
fi
fi
- if [ -n "${srctrigger}" -a ! -r ${srcdir}/${srctrigger} ] ; then
+ if [ ! -r ${srcdir}/${srctrigger} ] ; then
if [ -z "${srcdirdefaulted}" ] ; then
- echo "${progname}: Can't find ${srcname} sources in `pwd`/${srcdir}" 1>&2
+ echo '***' "${progname}: Can't find ${srcname} sources in ${PWD}/${srcdir}" 1>&2
else
- echo "${progname}: Can't find ${srcname} sources in `pwd`/. or `pwd`/.." 1>&2
+ echo '***' "${progname}: Can't find ${srcname} sources in ${PWD}/. or ${PWD}/.." 1>&2
fi
- echo \(At least ${srctrigger} is missing.\) 1>&2
+ echo '***' \(At least ${srctrigger} is missing.\) 1>&2
exit 1
fi
set ${links}; link=$1; shift; links=$*
if [ ! -r ${srcdir}/${file} ] ; then
- echo "${progname}: cannot create a link \"${link}\"," 1>&2
- echo "since the file \"${file}\" does not exist." 1>&2
+ echo '***' "${progname}: cannot create a link \"${link}\"," 1>&2
+ echo '***' "since the file \"${file}\" does not exist." 1>&2
exit 1
fi
${symbolic_link} ${srcdir}/${file} ${link} 2>/dev/null || ${hard_link} ${srcdir}/${file} ${link}
if [ ! -r ${link} ] ; then
- echo "${progname}: unable to link \"${link}\" to \"${srcdir}/${file}\"." 1>&2
+ echo '***' "${progname}: unable to link \"${link}\" to \"${srcdir}/${file}\"." 1>&2
exit 1
fi
- echo "Linked \"${link}\" to \"${srcdir}/${file}\"."
+
+ if [ -n "${verbose}" ] ; then
+ echo "Linked \"${link}\" to \"${srcdir}/${file}\"."
+ fi
done
# Create a .gdbinit file which runs the one in srcdir
# and tells GDB to look there for source files.
- case ${srcdir} in
- .)
- ;;
- *)
- echo "dir ." > .gdbinit
- echo "dir ${srcdir}" >> .gdbinit
- echo "source ${srcdir}/.gdbinit" >> .gdbinit
- ;;
- esac
+ if [ -r ${srcdir}/.gdbinit ] ; then
+ case ${srcdir} in
+ .)
+ ;;
+ *)
+ echo "# "${NO_EDIT} > .gdbinit
+ echo "dir ." >> .gdbinit
+ echo "dir ${srcdir}" >> .gdbinit
+ echo "source ${srcdir}/.gdbinit" >> .gdbinit
+ ;;
+ esac
+ fi
# Install a makefile, and make it set VPATH
# if necessary so that the sources are found.
# Define macro CROSS_COMPILE in compilation if this is a cross-compiler.
if [ "${host}" != "${target}" ] ; then
- echo "CROSS=-DCROSS_COMPILE" > Makefile
- echo "ALL=start.encap" >> Makefile
+ echo "CROSS=-DCROSS_COMPILE" > ${Makefile}
+ echo "ALL=all.cross" >> ${Makefile}
else
- echo "ALL=all.internal" > Makefile
+ echo "ALL=all.internal" > ${Makefile}
fi
# set target, host, VPATH
- echo "host = ${host}" >> Makefile
- echo "target = ${target}" >> Makefile
-
- if [ -n "${forcesubdirs}" ] ; then
- echo "subdir = /${hostsubdir}/${targetsubdir}" >> Makefile
- else
- echo "subdir =" >> Makefile
+ echo "host_alias = ${host_alias}" >> ${Makefile}
+ echo "host_cpu = ${host_cpu}" >> ${Makefile}
+ echo "host_vendor = ${host_vendor}" >> ${Makefile}
+ echo "host_os = ${host_os}" >> ${Makefile}
+ echo "version_path = ${version_path}" >> ${Makefile}
+ echo "target_alias = ${target_alias}" >> ${Makefile}
+ echo "target_cpu = ${target_cpu}" >> ${Makefile}
+ echo "target_vendor = ${target_vendor}" >> ${Makefile}
+ echo "target_os = ${target_os}" >> ${Makefile}
+
+# if [ -n "${subdirs}" ] ; then
+# (echo "subdir = /${subdirname}" ;
+# echo "unsubdir = ..") >> ${Makefile}
+# else
+ (echo "subdir =" ;
+ echo "unsubdir = .") >> ${Makefile}
+# fi
+
+ # echo "workdir = ${PWD}" >> ${Makefile}
+ echo "VPATH = ${srcdir}" >> ${Makefile}
+
+ # add "Makefile.in" (or whatever it's called)
+ cat ${srcdir}/${Makefile_in} >> ${Makefile}
+
+ # Conditionalize the makefile for this site.
+ if [ -n "${site}" ] ; then
+ site_makefile_frag=config/ms-${site}
+
+ if [ -f ${srcdir}/${site_makefile_frag} ] ; then
+ (echo "site_makefile_frag = ${srcdir}/${site_makefile_frag}" ;
+ sed -e "/^####/ r ${srcdir}/${site_makefile_frag}" ${Makefile}) > Makefile.tem
+ else
+ (echo "site_makefile_frag =" ;
+ cat ${Makefile}) > Makefile.tem
+ fi
+ mv Makefile.tem ${Makefile}
fi
- # echo "workdir = `pwd`" >> Makefile
- echo "VPATH = ${srcdir}" >> Makefile
-
- # add Makefile.in
- cat ${srcdir}/Makefile.in >> Makefile
-
- # and shake thoroughly.
# Conditionalize the makefile for this host.
if [ -f ${srcdir}/${host_makefile_frag} ] ; then
- sed -e "/^####/ r ${srcdir}/${host_makefile_frag}" Makefile > Makefile.tem
- mv Makefile.tem Makefile
+ (echo "host_makefile_frag = ${srcdir}/${host_makefile_frag}" ;
+ sed -e "/^####/ r ${srcdir}/${host_makefile_frag}" ${Makefile}) > Makefile.tem
+ else
+ (echo "host_makefile_frag =" ;
+ cat ${Makefile}) > Makefile.tem
fi
+ mv Makefile.tem ${Makefile}
# Conditionalize the makefile for this target.
if [ -f ${srcdir}/${target_makefile_frag} ] ; then
- sed -e "/^####/ r ${srcdir}/${target_makefile_frag}" Makefile > Makefile.tem
- mv Makefile.tem Makefile
+ (echo "target_makefile_frag = ${srcdir}/${target_makefile_frag}" ;
+ sed -e "/^####/ r ${srcdir}/${target_makefile_frag}" ${Makefile}) > Makefile.tem
+ else
+ (echo "target_makefile_frag =" ;
+ cat ${Makefile}) > Makefile.tem
fi
+ mv Makefile.tem ${Makefile}
# set srcdir
- sed "s@^srcdir = \.@srcdir = ${srcdir}@" Makefile > Makefile.tem
- mv Makefile.tem Makefile
+ sed "s:^srcdir[ ]*=.*$:srcdir = ${srcdir}:" ${Makefile} > Makefile.tem
+ mv Makefile.tem ${Makefile}
- # set destdir
- if [ -n "${destdir}" ] ; then
- sed "s:^destdir =.*$:destdir = ${destdir}:" Makefile > Makefile.tem
- mv Makefile.tem Makefile
+ # set prefix
+ if [ -n "${prefix}" ] ; then
+ sed "s:^prefix[ ]*=.*$:prefix = ${prefix}:" ${Makefile} > Makefile.tem
+ mv Makefile.tem ${Makefile}
fi
- # Remove all formfeeds, since some Makes get confused by them.
- sed "s/\f//" Makefile >> Makefile.tem
- mv Makefile.tem Makefile
+ # set datadir
+ if [ -n "${datadir}" ] ; then
+ sed "s:^datadir[ ]*=.*$:datadir = ${datadir}:" ${Makefile} > Makefile.tem
+ mv Makefile.tem ${Makefile}
+ fi
# reset SUBDIRS
- sed "s:^SUBDIRS =.*$:SUBDIRS = ${configdirs}:" Makefile > Makefile.tem
- mv Makefile.tem Makefile
+ sed "s:^SUBDIRS[ ]*=.*$:SUBDIRS = ${configdirs}:" ${Makefile} > Makefile.tem
+ mv Makefile.tem ${Makefile}
# reset NONSUBDIRS
- sed "s:^NONSUBDIRS =.*$:NONSUBDIRS = ${noconfigdirs}:" Makefile > Makefile.tem
- mv Makefile.tem Makefile
+ sed "s:^NONSUBDIRS[ ]*=.*$:NONSUBDIRS = ${noconfigdirs}:" ${Makefile} > Makefile.tem
+ mv Makefile.tem ${Makefile}
+
+ # remove any form feeds.
+ sed -e "s/\f//" ${Makefile} > Makefile.tem
+ mv Makefile.tem ${Makefile}
+
+ # prepend warning about editting.
+ echo "# "${NO_EDIT} > ${Makefile}.tem
+ cat ${Makefile} >> ${Makefile}.tem
+ mv Makefile.tem ${Makefile}
using=
if [ -f ${srcdir}/${host_makefile_frag} ] ; then
- using=" using \"${host_makefile_frag}\""
+ using="${using} and \"${host_makefile_frag}\""
fi
-
if [ -f ${srcdir}/${target_makefile_frag} ] ; then
- if [ -z "${using}" ] ; then
- andusing=" using \"${target_makefile_frag}\""
- else
- andusing="${using} and \"${target_makefile_frag}\""
- fi
- else
- andusing=${using}
+ using="${using} and \"${target_makefile_frag}\""
fi
-
- echo "Created \"Makefile\"" in `pwd`${andusing}.
-
- if [ "${host}" = "${target}" ] ; then
- echo "Links are now set up for use with a ${target}." \
- > config.status
- # | tee ${srcdir}/config.status
- else
- echo "Links are now set up for host ${host} and target ${target}." \
- > config.status
- # | tee ${srcdir}/config.status
+ if [ -n "${site}" -a \
+ -f ${srcdir}/${site_makefile_frag} ] ; then
+ using="${using} and \"${site_makefile_frag}\""
fi
+ using=`echo "${using}" | sed 's/and/using/'`
+ using="Created \"${Makefile}\" in ${PWD}${using}."
- originaldir=`pwd`
- cd ${srcdir}
- fi
- done # for each target
+ if [ -n "${verbose}" -o -z "${recurring}" ] ; then
+ echo ${using}
+ fi
-# # Now build a Makefile for this host.
-# if [ -n "${forcesubdirs}" ] ; then
-# cd ${hostsubdir}
-# cat > GNUmakefile << E!O!F
-## Makefile generated by configure for host ${host}.
-#
-#%:
-# for i in ${targets} ; do \
-# $(MAKE) -C Target-\$i \$@
-#
-#all clean stage1 stage2 stage3 stage4etags tags TAGS
-#E!O!F
-# fi
-done # for each host
+ . ${tmpfile}.pos
-# If there are subdirectories, then recurse.
+ # describe the chosen configuration in config.status.
+ # Make that file a shellscript which will reestablish
+ # the same configuration. Used in Makefiles to rebuild
+ # Makefiles.
-if [ -n "${norecurse}" -o -z "${configdirs}" ] ; then exit 0 ; fi
+ if [ -z "${norecursion}" ] ; then
+ arguments="${arguments} -norecursion"
+ fi
-# configdirs is not null
-for configdir in ${configdirs} ; do
- echo Configuring ${configdir}...
- specifics=
- commons=
+ echo "#!/bin/sh
+# ${NO_EDIT}
+# ${PWD} was configured as follows:
+${progname}" ${arguments} "
+# ${using}" > config.status
+ chmod a+x config.status
- if [ -n "${defaulttargets}" ] ; then
- for host in ${hosts} ; do
- if [ -d ${configdir}.${host} ] ; then
- newspecifics="${specifics} ${host}"
- specifics=${newspecifics}
- else
- newcommons="${commons} ${host}"
- commons=${newcommons}
- fi # if target specific
- done # for each host
-
- if [ -n "${commons}" ] ; then
- if [ -d ${configdir} ] ; then
- (cd ${configdir} ;
- ./configure ${commons} ${verbose} ${forcesubdirs} ${removing}) \
- | sed 's/^/ /'
- else
- echo Warning: directory \"${configdir}\" is missing.
- fi
- fi # if any common hosts
-
- if [ -n "${specifics}" ] ; then
- for host in ${specifics} ; do
- echo Configuring target specific directory ${configdir}.${host}...
- (cd ${configdir}.${host} ;
- ./configure ${host} ${verbose} ${forcesubdirs} ${removing}) \
- | sed 's/^/ /'
- done # for host in specifics
- fi # if there are any specifics
- else
+# originaldir=${PWD}
+# cd ${srcdir}
+ fi
- for target in ${targets} ; do
- if [ -d ${configdir}.${target} ] ; then
- newspecifics="${specifics} ${target}"
- specifics=${newspecifics}
- else
- newcommons="${commons} +target=${target}"
- commons=${newcommons}
- fi
+ # If there are subdirectories, then recur.
+ if [ -z "${norecursion}" -a -n "${configdirs}" ] ; then
+ for configdir in ${configdirs} ; do
+ if [ -n "${verbose}" ] ; then
+ echo Configuring ${configdir}...
+ fi
- done # check for target specific dir override
+ if [ -d ${srcdir}/${configdir} ] ; then
+ if [ "${srcdir}" != "." ] ; then
+ if [ ! -d ./${configdir} ] ; then
+ mkdir ./${configdir}
+ fi
+ fi
- if [ -n "${verbose}" ] ; then
- echo " "commons=\"${commons}\"
- echo " "specifics=\"${specifics}\"
- fi # if verbose
+ POPDIR=${PWD}
+ cd ${configdir}
+
+### figure out what to do with srcdir
+ case "${srcdir}" in
+ ".") ;; # do nothing. We're building in place.
+ /*) srcdiroption="-srcdir=${srcdir}/${configdir}" ;; # absolute path
+ *) srcdiroption="-srcdir=../${srcdir}/${configdir}" ;; # otherwise relative
+ esac
+
+### The recursion line is here.
+ if (${progname} -recurring ${host_alias} -target=${target_alias} \
+ ${verbose} ${subdirs} ${removing} ${prefixoption} \
+ ${tmpdiroption} ${namesubdiroption} ${datadiroption} \
+ ${srcdiroption}) ; then
+ true
+ else
+ exit 1
+ fi
- if [ -n "${commons}" ] ; then
- if [ -d ${configdir} ] ; then
- (cd ${configdir} ;
- ./configure ${hosts} ${verbose} ${forcesubdirs} ${removing} ${commons}) \
- | sed 's/^/ /'
- else
- echo Warning: directory \"${configdir}\" is missing.
- fi
- fi # if any commons
-
- if [ -n "${specifics}" ] ; then
- for target in ${specifics} ; do
- echo Configuring target specific directory ${configdir}.${target}...
- (cd ${configdir}.${target} ;
- ./configure ${hosts} ${verbose} ${forcesubdirs} ${removing} "+target=${target}") \
- | sed 's/^/ /'
+ cd ${POPDIR}
+ elif [ -n "${verbose}" ] ; then
+ echo Warning: source directory \"${srcdir}/${configdir}\" is missing.
+ fi
done
- fi # if any specifics
- fi # not default targets
-done
-
-exit 0
+ fi
+ done # for each target
+ # Now build a Makefile for this host.
+# if [ -n "${subdirs}" -a ! -n "${removing}" ] ; then
+# push=${PWD}
#
-# $Log$
-# Revision 1.15 1991/05/27 20:54:24 rich
-# fixed a bug in multiple targets
-#
-# Revision 1.14 1991/05/22 01:44:04 rich
-# remove gdb until config issues resolve.
+# if [ -n "${objdir}" ] ; then
+# cd ${objdir}
+# fi
#
-# Revision 1.13 1991/05/19 08:00:09 rich
-# Added gdb.
-#
-# Revision 1.12 1991/05/19 00:32:13 rich
-# Changes to deal with missing subdirs gracefully, and changes dictated
-# from dropping configure over gdb.
-#
-# Revision 1.4 1991/05/19 00:16:45 rich
-# Configure for gdb.
-#
-# Revision 1.10 1991/05/04 00:58:38 rich
-# Fix program name bug.
-#
-# Revision 1.9 1991/05/03 19:14:18 rich
-# Changed getopt to libiberty, commented out an aborted attempt at host
-# level Makefiles because it caused errors on +rm, add a warning for
-# directories expected to be removed on +rm but that don't exist.
-#
-# Revision 1.8 1991/04/24 16:50:59 rich
-# Three staging checkpoint.
-#
-# Revision 1.7 1991/04/17 01:34:47 rich
-# Added getopt for binutils, fixed problem with host dependancies in
-# configure.template.
-#
-# Revision 1.6 1991/04/16 00:18:44 rich
-# Now handles multiple hosts and targets.
-#
-# Revision 1.5 1991/04/15 23:43:44 rich
-# Now handles multiple hosts and targets.
-#
-# Revision 1.4 1991/04/13 02:11:03 rich
-# Config cut 3. We now almost install a29k.
-#
-# Revision 1.3 1991/04/11 02:41:54 rich
-# Cut 2 config. Subdirs.
+# cd ${hostsubdir}
+# cat > GNUmakefile << 'E!O!F'
+## Makefile generated by configure for host ${host_alias}.
#
+#ALL := $(shell ls -d T-*)
#
+#%:
+# $(foreach subdir,$(ALL),$(MAKE) -C $(subdir) \$@ &&) true
#
+#all:
+#E!O!F
+# cd ${push}
+# fi
+done # for each host
+
+### clean up.
+
+# trap cmd above handles this now:
+#rm -f ${tmpfile}.com ${tmpfile}.tgt ${tmpfile}.hst ${tmpfile}.pos
+
+exit 0
#
# Local Variables:
# End:
#
-# end of configure.template
+# end of configure